/* mpx.c - Repetidor */

/*---------------------------------------------------------------------
Modulo: mpx.c
Fecha: 27 Febrero 1996
Autor: Fernando J. Echevarrieta Fernandez
Version: 1.0

---------------------------------------------------------------------*/

#include <unistd.h>     /* fork */
#include <stdlib.h>     /* malloc */
#include <sys/types.h>
#include <sys/socket.h> /* socket, bind, listen */
#include <netinet/in.h> /* struct sockaddr_in */
#include <string.h>	/* strcmp, strcp, strcpy, memcpy */
#include <sys/time.h>	/* Macros FD */

#define MAXLENMSG  256
#define PORT 2001

char message[MAXLENMSG];
int client, ns, statuslen;
int file_desc, num_sock_set;
struct sockaddr_in mpx;

fd_set sock_set, active_sock_set;

main()
{
	int i;

	char message[MAXLENMSG];

	/* Goes to background */ 
	if ( fork() != 0 ) {
	   printf("mpx: OK\n");
	   exit(0);
	}

	/* Starts communication processes */
	client   = launch(); 

	num_sock_set = getdtablesize();
	FD_ZERO(&active_sock_set);

	FD_SET(client,    &active_sock_set);

	while (1) {
	    bcopy((char *)&active_sock_set,(char *)&sock_set,sizeof(sock_set));

	    select(num_sock_set,&sock_set,(fd_set *)0,(fd_set *)0,
                   (struct timeval *)0); 

            if (FD_ISSET(client, &sock_set)) {
                ns=create_slave_sock(client);
                printf("Abierto socket esclavo [%d]\n",ns);
                FD_SET(ns, &active_sock_set);
            }

            /* Three first desc are STD IN/OUT/ERR */
            for (file_desc=3; file_desc < num_sock_set; ++file_desc)

		if ((file_desc != client) &&
                     FD_ISSET(file_desc,&sock_set))

                    if (client_process(file_desc) == 0) {
                        close(file_desc);
                        printf("Cerrado socket esclavo [%d]\n",file_desc);
                        FD_CLR(file_desc, &active_sock_set);
                    }
	}

}

/* ---------------------------------------------------------------- */

launch()
/* Launches server for client program */
{
	int s;

	mpx.sin_family=AF_INET;
	mpx.sin_port  =htons(PORT);
	mpx.sin_addr.s_addr=inet_addr("127.0.0.1");

        /* Creates socket*/
        s=socket(AF_INET, SOCK_STREAM, 0);
        if (s<0) 
        {
                perror("server:socket");
                exit(1);
        }

        /* Binds it to the port */
        if (bind(s,(struct sockaddr *)&mpx,sizeof(mpx)) < 0) 
        {
                perror("server:bind");
                exit(1);
        }

        /* And listens */
        listen(s,3);

	/* Returns socket descriptor */
	return s;

} /* end launch */

/* ---------------------------------------------------------------- */

client_process(int socket)
/* Processes a client request */
{
        char buf[256];
        int c;

        if ((c=read(socket,buf,MAXLENMSG)) > 0) {
	   buf[c]='\0';
           printf("mpx: message received: '%s'\n",buf);

           for (file_desc=0; file_desc < num_sock_set; ++file_desc)

               /* Retransmision to all slave sockets */
               if ((file_desc != client) &&
                   FD_ISSET(file_desc,&active_sock_set))
                   write(file_desc,buf,c);
        }

        return c;

}

/* ---------------------------------------------------------------- */

create_slave_sock(int s)
/* Returns a new socket ns and puts requests in buf */
{
        int ns;
        int c;
        char buf[256];

        /* Accepts incomming connection */
        statuslen=sizeof(mpx);
        ns=accept(s,INADDR_ANY,&statuslen);
        if (ns<0) 
        {
                printf("server:accept error %s\n",ns);
                exit(1);
        }

        /* Protocolo de echo como confirmacion */
        c=read(ns,buf,MAXLENMSG);
        printf("mpx: socket[%d] message:'%s'\n",ns,buf);
        write(ns,buf,c);

        return ns;

} /* end create_slave_sock */

/* ---------------------------------------------------------------- */
